
#include "stdafx.h"
#include "x86.h"

u8 bsdf2;
u8 mojs;
u8 mojs2;

#if 0
void tests()
{
	u8 bsdf;
}
#endif
/*
 =======================================================================================================================
 =======================================================================================================================
 */

u8  *x86Ptr;

/* call func */
void CALLFunc(u32 func) {
	CALL32(func - ((u32)x86Ptr + 5));
}
void JMPFunc(u32 func) {
	JMP_Long(func - ((u32)x86Ptr + 5));
}

u8* x86GetPtr() { return x86Ptr; }
void x86SetPtr(u8 *ptr) {x86Ptr = ptr;}

void x86SetJ8(u8 *j8) {
	u32 jump = (x86Ptr - j8) - 1;

	if (jump > 0x7f) printf("j8 greater than 0x7f!!\n"); 
	*j8 = (u8)jump;
}

#define DISP32 5
#define ModRM(mod, rm, reg) WC8((mod << 6) | (rm << 3) | (reg));

void OR32ItoM(u32 to, u32 from) {
	WC8(0x81); 
	ModRM(0, 1, DISP32);
	WC32(to);
	WC32(from); 
}

#define J8Rel(cc, to) { WC8(cc); WC8(to); return (u8*)(x86Ptr - 1); }
u8* JMP8(u8 to) { J8Rel(0xEB, to); }
u8* JZ8(u8 to)  { J8Rel(0x74, to); }
u8* JG8(u8 to)  { J8Rel(0x7F, to); }
u8* JGE8(u8 to) { J8Rel(0x7D, to); }
u8* JL8(u8 to)  { J8Rel(0x7C, to); }
u8* JLE8(u8 to) { J8Rel(0x7E, to); }
u8* JA8(u8 to)  { J8Rel(0x77, to); }
u8* JAE8(u8 to) { J8Rel(0x73, to); }
u8* JB8(u8 to)  { J8Rel(0x72, to); }
u8* JBE8(u8 to) { J8Rel(0x76, to); }
u8* JNZ8(u8 to) { J8Rel(0x75, to); }
u8* JC8(u8 to)  { J8Rel(0x72, to); }
u8* JNC8(u8 to) { J8Rel(0x73, to); }

void CALL32(u32 to) {
	WC8(0xE8); 
	WC32(to); 
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */

//schibo's starts here

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void Dummy2(unsigned int, unsigned int)
{
//Do nothing. Used for calling nothing with 2 parameters.
}

void Dummy4(unsigned int, unsigned int, unsigned int, unsigned int)
{
//Do nothing. Used for calling nothing with 4 parameters.
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void WC8(u32 bValue)
{
	*(u8*)x86Ptr = bValue; 
	x86Ptr++; 
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void WC16(u32 wValue)
{
	*(u16*)x86Ptr = wValue; 
	x86Ptr += 2; 
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void WC32(u32 dwValue)
{
	*(u32*)x86Ptr = dwValue; 
	x86Ptr += 4; 
}

void Encode_Slash_R(u32 Reg, u32 ModRM, u32 Address)	/* so-named for the /r mnemonic in
																					 * Intel x86 docs */
{
	if((ModRM >= ModRM_disp8_EAX) && (ModRM <= ModRM_disp8_EDI))
	{
		WC8( (ModRM | (Reg << 3)));
		WC8( Address);
	}
	else if((ModRM >= ModRM_disp32_EAX) && (ModRM <= ModRM_disp32_EDI))
	{
		if(Address == 0)
		{
			ModRM -= ModRM_disp32_EAX;
			WC8( (ModRM | (Reg << 3)));
		}
		else
		{
			WC8( (ModRM | (Reg << 3)));
			WC32(Address);
		}
	}
	else
	{
		WC8( (ModRM | (Reg << 3)));
		if(Address != 0) WC32(Address);
	}
}



/*
 =======================================================================================================================
 =======================================================================================================================
 */
void ADD_Reg2ToReg1(u32 OperandSize, u32 Reg1, u32 Reg2, u32 FlagsMatter)
{
	WC8( (0x02 | OperandSize));
	WC8( (0xC0 | (Reg1 << 3) | Reg2));
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void SUB_Reg2FromReg1(u32 OperandSize, u32 Reg1, u32 Reg2, u32 FlagsMatter)
{
	WC8( (0x28 | OperandSize));
	WC8( (0xC0 | (Reg2 << 3) | Reg1));
}

void SBB_Reg2FromReg1(u32 OperandSize, u32 Reg1, u32 Reg2)
{
	WC8( (0x1B | OperandSize));
	WC8( (0xC0 | (Reg1 << 3) | Reg2));
}


/*
 =======================================================================================================================
 CMOV is for Pentium Pro and above
 =======================================================================================================================
 */
void CMOVcc_Reg2ToReg1(u8 ConditionCode, u8 Reg1, u8 Reg2)
{
	WC8( 0x0F);
	WC8( (0x40 | ConditionCode));
	WC8( (0xC0 | (Reg1 << 3) | Reg2));
}



/*
 =======================================================================================================================
 =======================================================================================================================
 */
void ADD_MemoryToReg(u32 OperandSize, u32 Reg, u32 ModRM, u32 Address)
{
    WC8( (0x02 | OperandSize));
	Encode_Slash_R(Reg, ModRM, Address);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void AND_MemoryToReg(u32 OperandSize, u32 Reg, u32 ModRM, u32 Address)
{

// This optimization is not used enough to be able to test it. Not worth it now.
//    if (ModRM == (0xC0|Reg))
//    {
//       MessageBox(0, "Match", "", 0);
//        //AND_Reg2ToReg1(1, Reg, ModRM-0xC0);
//        return;
//    }



    WC8( (0x22 | OperandSize));
	Encode_Slash_R(Reg, ModRM, Address);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void SUB_MemoryToReg(u32 OperandSize, u32 Reg, u32 ModRM, u32 Address)
{
    
   
    WC8( (0x2A | OperandSize));
	Encode_Slash_R(Reg, ModRM, Address);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void OR_MemoryToReg(u32 OperandSize, u32 Reg, u32 ModRM, u32 Address)
{
    WC8( (0x0A | OperandSize));
	Encode_Slash_R(Reg, ModRM, Address);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void XOR_MemoryToReg(u32 OperandSize, u32 Reg, u32 ModRM, u32 Address)
{
    WC8( (0x32 | OperandSize));
	Encode_Slash_R(Reg, ModRM, Address);
}


void SUB_ImmFromReg(u32 OperandSize, u32 Reg, u32 Data, u32 PreserveFlags)
{
    if((Data == 0)&&(!PreserveFlags)) return;

    if(OperandSize == 1)
	{
		if((Data < 128) || (Data >= (0xffffff80)))	// [-128 to 127] 
		{
			SUB_Imm8sxToReg(1, Reg, (unsigned char) Data, PreserveFlags);
			return;
		}
	}

	if(Reg == Reg_EAX)
	{
		WC8( (0x2C | OperandSize));	// SUB_ImmToEAX 
	}
	else
	{
		WC8( (0x80 | OperandSize));
		WC8( (0xE8 | Reg));
	}

	if(OperandSize == 0)
		WC8( Data);
	else
		WC32(Data);

}

/*
 =======================================================================================================================
    Danger: if Operand size == 0!. Fix! (Fortunately we never use 0 yet)
 =======================================================================================================================
 */
void ADD_ImmToReg(u32 OperandSize, u32 Reg, u32 Data, u32 PreserveFlags)
{
    if((Data == 0)&&(!PreserveFlags)) return;

	if(OperandSize == 1)
	{
		if((Data < 128) || (Data >= (0xffffff80)))	// [-128 to 127] 
		{
			ADD_Imm8sxToReg(1, Reg, (unsigned char) Data);
			return;
		}
	}

	if(Reg == Reg_EAX)
	{
		WC8( (0x04 | OperandSize));	// ADD_ImmToEAX 
	}
	else
	{
		WC8( (0x80 | OperandSize));
		WC8( (0xC0 | Reg));
	}

	if(OperandSize == 0)
		WC8( Data);
	else
		WC32(Data);
}





/*
 =======================================================================================================================
 =======================================================================================================================
 */
void AND_ImmToEAX(u32 OperandSize, u32 Data)
{
	WC8( (0x24 | OperandSize));
	if(OperandSize == 0)
		WC8( Data);
	else
		WC32(Data);
}

/*
 =======================================================================================================================
    Be careful with operandsize = 0!. there is no esl, edl
 =======================================================================================================================
 */
void AND_ImmToReg(u32 OperandSize, u32 Reg, u32 Data, u32 FlagsMatter)
{
	if((Data == 0xffffffff)&&(!FlagsMatter)) return;
	if(OperandSize == 1)
	{
		if(Data == 0) //xor same flags as and
		{
			XOR_Reg2ToReg1(1, Reg, Reg, FlagsMatter);
			return;
		}

		if((Data < 128) || (Data >= (0xffffff80)))	// [-128 to 127] 
		{
			AND_Imm8sxToReg(OperandSize, Reg, (unsigned char) Data);
			return;
		}
	}

	if(Reg == Reg_EAX)
	{
		AND_ImmToEAX(OperandSize, Data);
		return;
	}

	WC8( (0x80 | OperandSize));
	WC8( (0xE0 | Reg));
	if(OperandSize != 0)
		WC32(Data);
	else
		WC8( (Data & 0xFF));
}

void TEST_ImmToEAX(u32 OperandSize, u32 Data)
{
	WC8(0xa8 | OperandSize);
	if(OperandSize != 0)
		WC32(Data);
	else
		WC8( (Data & 0xFF));
}

void TEST_ImmToReg(u32 OperandSize, u32 Reg, u32 Data)
{
	if (Reg == Reg_EAX)
	{
		TEST_ImmToEAX(OperandSize,Data);
		return;
	}
	WC8(0xf6 | OperandSize);
	WC8(0xc0 | Reg);
	if(OperandSize != 0)
		WC32(Data);
	else
		WC8( (Data & 0xFF));
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void AND_ImmToMemory(u32 Address, u32 Data)
{
	if(Data == 0xffffffff) return;
	WC8( 0x81);
	WC8( 0x25);
	WC32(Address);
	WC32(Data);
}
void OR_ImmToMemory(u32 Address, u32 Data)
{
	int OperandSize = 1;
	if(Data == 0x0) return;
	WC8( 0x80 | OperandSize);
	WC8( 0x0d);
	WC32(Address);
	if (OperandSize==1)
		WC32(Data);
	else
		WC8(Data);
}

void X86_CALL(u32 dwAddress)
{

}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void CALL_Reg(u32 Reg)
{
	
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void CDQ()
{
	WC8( 0x99);
}


void LAHF()
{
	WC8(0x9F);
}

void CMC()
{
	WC8(0xF5);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void CMP_Reg1WithReg2(u32 OperandSize, u32 Reg1, u32 Reg2)
{
	WC8( (0x38 | OperandSize));
	WC8( (0xC0 | (Reg1 << 3) | Reg2));
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void CMP_Reg2WithReg1(u32 OperandSize, u32 Reg1, u32 Reg2)
{
	WC8( (0x3A | OperandSize));
	WC8( (0xC0 | (Reg1 << 3) | Reg2));
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void CMP_EAXWithImm(u32 OperandSize, u32 Data)
{
	WC8( (0x3C | OperandSize));
	WC32(Data);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void CMP_RegWithImm(u32 OperandSize, u32 Reg, u32 Data)
{
	if(OperandSize == 1)
	{
		if(Data == 0)
		{
			if(Reg == Reg_EAX)
			{
				TEST_EAXWithEAX();
				return;
			}

			TEST_Reg2WithReg1(1, Reg, Reg);
			return;
		}

		if((Data < 128) || (Data >= (0xffffff80)))	// [-128 to 127] 
		{
			CMP_sImm8WithReg(1, Reg, (unsigned char) Data);
			return;
		}

		if(Reg == Reg_EAX)
		{
			CMP_EAXWithImm(1, Data);
			return;
		}
	}

	WC8( (0x80 | OperandSize));
	WC8( (0xF8 | Reg));
	WC32(Data);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void CMP_RegWithShort(u32 OperandSize, u32 Reg, u32 Data)
{
	if(OperandSize == 1)
	{
		if(Data == 0)
		{
			if(Reg == Reg_EAX)
			{
				TEST_EAXWithEAX();
				return;
			}

			TEST_Reg2WithReg1(1, Reg, Reg);
			return;
		}
	}

	WC8( (0x82 | OperandSize));	/* assumed for now..verify */
	WC8( (0xF8 | Reg));
	WC8(Data);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void CMP_MemoryWithImm(u32 OperandSize, u32 dwAddress, u32 Data)
{
	WC8( (0x80 | OperandSize));
	WC8( 0x3D);
	WC32(dwAddress);
	WC32(Data);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void CMP_RegWithMemory(u32 OperandSize, u32 Reg, u32 dwAddress)
{
	WC8(0x3A|OperandSize);
	WC8( (0x05 | (Reg << 3)));
	WC32(dwAddress);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void FABS()
{
	WC8(0xd9);
	WC8(0xe1);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void FADD_Memory(u32 OperandSize, u32 dwAddress)
{
	WC8( (0xD8 + OperandSize));
	WC8(0x05);
	WC32(dwAddress);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void FCOMP_Memory(u8 OperandSize, u32 dwAddress)
{
	WC8( (0xD8 + OperandSize));
	WC8(0x1D);
	WC32(dwAddress);
}

/*
=======================================================================================================================
=======================================================================================================================
*/
void FCOMIP(int i)
{
	WC8(0xDF);
	WC8(0xF0+i);
}

/*
=======================================================================================================================
=======================================================================================================================
*/
void FUCOMIP(int i)
{
	WC8(0xDF);
	WC8(0xE8+i);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void FNSTSW()
{
	WC8(0xDF);
	WC8(0xE0);
}

/*
=======================================================================================================================
=======================================================================================================================
*/
void FTEST()
{
	WC8(0xD9);
	WC8(0xE4);
}
/*
=======================================================================================================================
=======================================================================================================================
*/
void FFREEP()
{
	WC8(0xDF);
	WC8(0xC0);
}

/*
=======================================================================================================================
=======================================================================================================================
*/
void FCMOVB(int i)
{
	WC8(0xDA);
	WC8(0xC0+i);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void FDIV_Memory(u8 OperandSize, u32 dwAddress)
{
	WC8( (0xD8 + OperandSize));
	WC8(0x35);
	WC32(dwAddress);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void FISTP_Memory(u8 OperandSize, u32 dwAddress)
{
	WC8( (0xDB + OperandSize));
	
    if (OperandSize == FORMAT_QUAD)
    {
        WC8(0x05+(8*7));
	    WC32(dwAddress);
    }
    else
    {
        WC8(0x05+(8*3));
	    WC32(dwAddress);
    }
}



void FLD1()
{
	WC8(0xD9);
	WC8(0xE8);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void FLD_Memory(u8 OperandSize, u32 dwAddress)
{
	WC8( (0xD9 + OperandSize));
	WC8(0x05);
	WC32(dwAddress);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void FLDCW_Memory(u32 dwAddress)
{
	WC8(0xd9);
	WC8(0x2d);
	WC32(dwAddress);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void FILD_Memory(u8 OperandSize, u32 dwAddress)
{
	WC8( (0xDB + OperandSize));
	
    if (OperandSize == FORMAT_QUAD)
        WC8(0x2D);
    else
        WC8(0x05);

	WC32(dwAddress);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void FMUL_Memory(u8 OperandSize, u32 dwAddress)
{
	WC8( (0xD8 + OperandSize));
	WC8(0x0d);
	WC32(dwAddress);
}

/*
=======================================================================================================================
=======================================================================================================================
*/
void FDIVP()
{
	WC8(0xde);
	WC8(0xf9);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void FNEG()
{
	WC8(0xd9);
	WC8(0xe0);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void FRNDINT()
{
	WC8(0xD9);
	WC8(0xFC);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void FSQRT()
{
	WC8(0xd9);
	WC8(0xfa);
}

/*
=======================================================================================================================
=======================================================================================================================
*/
void FST_Memory(u8 OperandSize, u32 dwAddress)
{
	WC8( (0xd9 + OperandSize));
	WC8(0x15);
	WC32(dwAddress);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void FSTP_Memory(u8 OperandSize, u32 dwAddress)
{
	WC8( (0xd9 + OperandSize));
	WC8(0x1d);
	WC32(dwAddress);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void FSUB_Memory(u8 OperandSize, u32 dwAddress)
{
	WC8( (0xD8 + OperandSize));
	WC8(0x25);
	WC32(dwAddress);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void IMUL_EAXWithReg(u32 OperandSize, u32 Reg)
{
	WC8( (0xF6 | OperandSize));
	WC8( (0xE8 | Reg));
}



/*
 =======================================================================================================================
 =======================================================================================================================
 */
void IMUL_EAXWithMemory(u32 OperandSize, u32 Address)
{
	WC8( (0xF6 | OperandSize));
	WC8( (0x2D));
	WC32(Address);
}

void IMUL32_ImmWithReg(u32 OperandSize, u32 Reg, u32 Immediate, u32 FlagsMatter)
{
	WC8( 0x69);
	WC8( (0xC0 | (Reg << 3) | Reg));
	WC32(Immediate);
}


/*
 =======================================================================================================================
    Incomplete..assumed: operandsize = 1
 =======================================================================================================================
 */
void DEC_Reg(u32 OperandSize, u32 Reg)
{
	
	if(OperandSize == 1)
	{
		WC8( (0x48 | Reg));
	}
	else
	{
		MessageBox(0, "DEC: Incomplete", "", 0);
	}
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void INC_Reg(u32 OperandSize, u32 Reg)
{
	if(OperandSize == 1)
	{
		WC8( (0x40 | Reg));
	}
	else
	{
		WC8(0xfe);
		WC8( (0xc0 | Reg));
	}
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void DIV_EAXWithReg(u32 OperandSize, u32 Reg)
{
	WC8( (0xF6 | OperandSize));
	WC8( (0xF0 | Reg));
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void IDIV_EAXWithReg(u8 OperandSize, u8 Reg)
{
	WC8( (0xF6 | OperandSize));
	WC8( (0xF8 | Reg));
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void Jcc(u8 ConditionCode, u8 Offset)
{
	WC8( (0x70 | ConditionCode));
	WC8( Offset);
}


/*
 =======================================================================================================================
 =======================================================================================================================
 */
void JMP_Short(u8 Offset)
{
	WC8( 0xEB);
	WC8( Offset);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void JMP_Long(u32 dwAddress)
{
	WC8(0xE9);
	WC32(dwAddress);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void JMP_FAR(u32 dwAddress)
{
	WC8(0xFF);
	WC8(0x25);
	WC32(dwAddress);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void LEA(u32 OperandSize, u32 Reg, u32 ModRM, u32 Address)
{
	WC8(0x8D);
	Encode_Slash_R(Reg, ModRM, Address);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void MOV_Reg2ToReg1(u32 OperandSize, u32 Reg1, u32 Reg2)
{
	if(Reg1 == Reg2) return;
	WC8( (0x8A | OperandSize));
	WC8( (0xC0 | (Reg1 << 3) | Reg2));
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void MOV_MemoryToReg(u32 OperandSize, u32 Reg, u32 ModRM, u32 Address)
{
    if (ModRM  == (0xC0|Reg))
    {
        return;
    }


    
    if((Reg == Reg_EAX) && (ModRM == ModRM_disp32))
	{
		MOV_MemoryToEAX(OperandSize, Address);
		return;
	}

	WC8( (0x8A | OperandSize));
	Encode_Slash_R(Reg, ModRM, Address);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void MOV_ModRMToReg(u32 OperandSize, u32 Reg, u32 ModRM)
{
	if(Reg == Reg_ESP || Reg == Reg_EBP)
		MessageBox(0, "Fix me in function MOV_ModRMToReg(), does not support ESP and EBP", "", 0);
	WC8( (0x8A | OperandSize));
	WC8( ((Reg << 3) | ModRM));
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void MOV_RegToModRM(u32 OperandSize, u32 Reg, u32 ModRM)
{
	if(Reg == Reg_ESP || Reg == Reg_EBP)
		MessageBox(0, "Fix me in function MOV_regToModRM(), does not support ESP and EBP", "", 0);
	WC8( (0x88 | OperandSize));
	WC8( ((Reg << 3) | ModRM));
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void MOVSX_MemoryToReg(u32 OperandSize, u32 Reg, u32 ModRM, u32 Address)
{
	WC8(0x0F);
	WC8( (0xBE | OperandSize));
	WC8( (ModRM | (Reg << 3)));
	if(Address != 0) WC32(Address);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void MOVZX_MemoryToReg(u32 OperandSize, u32 Reg, u32 ModRM, u32 Address)
{
	WC8(0x0F);
	WC8( (0xB6 | OperandSize));
	WC8( (ModRM | (Reg << 3)));
	if(Address != 0) WC32(Address);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void MOV_MemoryToEAX(u32 OperandSize, u32 Address)
{
	WC8( (0xA0 | OperandSize));
	WC32(Address);
}

/*
 =======================================================================================================================
    1964 uses ebp as a ponter to the middle of the Mips GPR array in memory. 
    Address can also represent displacement.
 =======================================================================================================================
 */
void MOV_RegToMemory(u32 OperandSize, u32 Reg, u32 ModRM, u32 Address)
{
    
    if((Reg == Reg_EAX) && (ModRM == ModRM_disp32))
	{
		MOV_EAXToMemory(OperandSize, Address);
		return;
	}

	WC8( (0x88 | OperandSize));
	Encode_Slash_R(Reg, ModRM, Address);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void MOV_EAXToMemory(u32 OperandSize, u32 Address)
{
	WC8( (0xA2 | OperandSize));
	WC32(Address);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void MOV_ImmToReg(u32 OperandSize, u32 Reg, u32 Data, u32 PreserveFlags)
{

	if(OperandSize == 1)
	{
		if(Data == 0 && !PreserveFlags)
		{
			XOR_Reg2ToReg1(1, Reg, Reg, 0);
			return;
		}
		if (Data == -1 && !PreserveFlags)
		{
			OR_ImmToReg(1, Reg, 0xFFFFFFFF, 0);
			return;
		}
	}

	WC8( (0xB0 | (OperandSize << 3) | Reg));
	if(OperandSize == 0)
	{
		WC8( Data);
	}
	else
	{
		WC32(Data);
	}
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void MOV_ImmToMemory(u8 OperandSize, u8 ModRM, u32 Address, u32 Data)
{
	WC8( (0xC6 | OperandSize));
	if((ModRM >= ModRM_disp8_EAX) && (ModRM <= ModRM_disp8_EDI))
	{
		if((Address == 0) && (ModRM != ModRM_disp8_EBP) && (ModRM != ModRM_disp8_SIB)) 
			ModRM -= 0x40;
		WC8( (ModRM));
		if((Address == 0) && (ModRM == ModRM_EBP))
			WC8(0x28);
		else
			WC8( Address);
	}
	else
	{
		WC8( (ModRM));
		if(Address != 0) WC32(Address);
	}

	if(OperandSize == 1)
		WC32(Data);
	else
		WC8((unsigned __int8) (Data));
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void MUL_EAXWithReg(u32 OperandSize, u32 Reg)
{
	WC8( (0xF6 | OperandSize));
	WC8( (0xE0 | Reg));
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void MUL_EAXWithMemory(u32 OperandSize, u32 Address)
{
	WC8( (0xF6 | OperandSize));
	WC8( (0x25));
	WC32(Address);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void NEG_Reg(u32 OperandSize, u32 Reg)
{
	WC8( (0xF6 | OperandSize));
	WC8( (0xD8 | Reg));
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void NOT_Reg(u32 OperandSize, u32 Reg)
{
	WC8( (0xF6 | OperandSize));
	WC8( (0xD0 | Reg));
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void NOP()
{
	WC8( 0x90);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void OR_ImmToEAX(u32 OperandSize, u32 Data)
{
	WC8( (0x0C | OperandSize));
	if(OperandSize == 0)
		WC8( Data);
	else
		WC32(Data);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void OR_ImmToReg(u32 OperandSize, u32 Reg, u32 Data, u32 FlagsMatter)
{
	if ((Data == 0)&&(!FlagsMatter)) return;

	if(OperandSize == 1)
	{
		if((Data < 128) || (Data >= (0xffffff80)))	/* [-128 to 127] */
		{
			OR_ShortToReg(1, Reg, Data);
			return;
		}
	}

	if(Reg == Reg_EAX)
	{
		OR_ImmToEAX(OperandSize, Data);
		return;
	}

	WC8( (0x80 | OperandSize));
	WC8( (0xC8 | Reg));
	if(OperandSize != 0)
		WC32(Data);
	else
		WC8( (Data & 0xFF));
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void OR_RegToMemory(u8 OperandSize, u8 Reg, u8 ModRM, u32 Address)
{
	WC8( (0x0A | OperandSize));
	Encode_Slash_R(Reg, ModRM, Address);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void POP_RegFromStack(u32 Reg)
{
	WC8( (0x58 | Reg));
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void POPA()
{
	WC8( 0x66);
	WC8( 0x61);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void POPAD()
{
	WC8( 0x61);
}

void PUSHF()
{
	WC8(0x9C);
}
void POPF()
{
	WC8(0x9D);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void PUSH_RegToStack(u32 Reg)
{
	WC8( (0x50 | Reg));
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void PUSH_WordToStack(unsigned __int32 wWord)
{
	WC8(0x68);
	WC32(wWord);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void PUSHA()
{
	WC8( 0x66);
	WC8( 0x60);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void PUSHAD()
{
	WC8( 0x60);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void RET()
{
	WC8( 0xC3);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void SAHF()
{
	WC8(0x9e);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void SETcc_Reg(u32 ConditionCode, u32 Reg)
{
	WC8( 0x0F);
	WC8( (0x90 | ConditionCode));
	WC8( (0xC0 | Reg));
}

void SETcc_ToMemory(u32 ConditionCode, u32 Address)
{
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void SAR_RegByCL(u32 OperandSize, u32 Reg)
{
	WC8( (0xD2 | OperandSize));
	WC8( (0xF8 | Reg));
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void SHL_RegByImm(u32 OperandSize, u32 Reg, u32 Data)
{
	if(Data == 0) return;
	if(Data == 1)
	{
		ADD_Reg2ToReg1(1, Reg, Reg, 1);
		return;
	}

	if(Data == 2)
	{
		/* lea reg, [reg*4] */
		WC8(0x8D);
		WC8((u8) (0x04 | (Reg << 3)));
		WC8((u8) (0x85 | (Reg << 3)));
		WC32(0x00);
		return;
	}

	if(Data == 3)
	{
		/* lea reg, [reg*8] */
		WC8(0x8D);
		WC8((u8) (0x04 | (Reg << 3)));
		WC8((u8) (0xC5 | (Reg << 3)));
		WC32(0x00);
		return;
	}

	WC8( (0xC0 | OperandSize));
	WC8( (0xE0 | Reg));
	WC8( Data);
}

/*
=======================================================================================================================
=======================================================================================================================
*/
void ROL_RegByImm(u32 OperandSize, u32 Reg, u32 Data, u32 FlagsMatter)
{
	if((Data == 0)&&(!FlagsMatter)) return;

	if (Data == 1)
	{
		WC8(0xD0|OperandSize);
		WC8(0xC0 | Reg);
	}
	else
	{
		WC8( (0xC0 | OperandSize));
		WC8( (0xC0 | Reg));
		WC8( Data );
	}
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void SHR_RegByImm(u32 OperandSize, u32 Reg, u32 Data)
{
	if(Data == 0) return;
	if(Data == 1)
	{
		SHR_RegBy1(OperandSize, Reg);
		return;
	}

	WC8( (0xC0 | OperandSize));
	WC8( (0xE8 | Reg));
	WC8( Data);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void SAR_RegByImm(u32 OperandSize, u32 Reg, u32 Data)
{
	if(Data == 0) return;
	if(Data == 1)
	{
		SAR_RegBy1(OperandSize, Reg);
		return;
	}

	WC8( (0xC0 | OperandSize));
	WC8( (0xF8 | Reg));
	WC8( Data);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void SHR_RegBy1(u32 OperandSize, u32 Reg)
{
	WC8( (0xD0 | OperandSize));
	WC8( (0xE8 | Reg));
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void SAR_RegBy1(u8 OperandSize, u8 Reg)
{
	WC8( (0xD0 | OperandSize));
	WC8( (0xF8 | Reg));
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void SHL_RegByCL(u32 OperandSize, u32 Reg)
{
	WC8( (0xD2 | OperandSize));
	WC8( (0xE0 | Reg));
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void SHR_RegByCL(u32 OperandSize, u32 Reg)
{
	WC8( (0xD2 | OperandSize));
	WC8( (0xE8 | Reg));
}


/*
 =======================================================================================================================
 =======================================================================================================================
 */
void DEC_Memory(u8 OperandSize, u32 Address)
{

	WC8( (0xFE | OperandSize));
	WC8(0x0D);	/* Disp32 */
	WC32(Address);
}

//UNTESTED
void MOVSX_B_Reg2ToReg1(int lreg, int xreg) {WC8(0x0f);WC8(0xbe);WC8(0xC0 | (xreg<<3) | lreg);}
void MOVZX_B_Reg2ToReg1(int lreg, int xreg) {WC8(0x0f);WC8(0xb6);WC8(0xC0 | (xreg<<3) | lreg);}
void MOVSX_W_Reg2ToReg1(int lreg, int xreg) {WC8(0x0f);WC8(0xbf);WC8(0xC0 | (xreg<<3) | lreg);}
void MOVZX_W_Reg2ToReg1(int lreg, int xreg) {WC8(0x0f);WC8(0xb7);WC8(0xC0 | (xreg<<3) | lreg);}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void ADD_ImmToMemory(u32 Address, u32 Data)
{
//    if (Data == -1) {DEC_Memory(1, Address); return;} //not worth the trouble.

		if((Data < 128) || (Data >= (0xffffff80)))	/* [-128 to 127] */
		{
            WC8( 0x83);
        	WC8( 0x05);
        	WC32(Address);
            WC8( Data);
        }
        else
        {
            WC8( 0x81);
        	WC8( 0x05);
        	WC32(Address);
        	WC32((unsigned long) (Data));
        }
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void XOR_ImmToMemory(u32 Address, u32 Data)
{
//    if (Data == -1) {DEC_Memory(1, Address); return;} //not worth the trouble.

		if((Data < 128) || (Data >= (0xffffff80)))	/* [-128 to 127] */
		{
            WC8( 0x83);
        	WC8( 0x05);
        	WC32(Address);
            WC8( Data);
        }
        else
        {
            WC8( 0x81);
        	WC8( 0x05);
        	WC32(Address);
        	WC32((unsigned long) (Data));
        }
}

/*
 =======================================================================================================================
    Assumed, Operand size = 1
 =======================================================================================================================
 */
void SUB_ImmToMemory(u32 Address, u32 Data)
{
		if((Data < 128) || (Data >= (0xffffff80)))	/* [-128 to 127] */
		{
            WC8( 0x83);
        	WC8( 0x2D);
        	WC32(Address);
            WC8( Data);
        }
        else
        {
            WC8( 0x81);
        	WC8( 0x2D);
        	WC32(Address);
        	WC32((unsigned long) (Data));
        }
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void TEST_ImmWithMemory(u32 dwAddress, u32 Value)
{
	WC8(0xf7);
	WC8(0x05);
	WC32(dwAddress);
	WC32(Value);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void TEST_EAXWithImm(u8 OperandSize, u32 dwAddress)
{
	WC8( (0xa8 | OperandSize));
	WC32(dwAddress);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void TEST_EAXWithEAX()
{
	WC8(0x85);
	WC8(0xc0);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void TEST_Reg2WithReg1(u8 OperandSize, u8 Reg1, u8 Reg2)
{
	if(Reg2 == Reg1)
	{
		if
		(Reg1 == Reg_EAX)
		{
			TEST_EAXWithEAX();
		}
		else
		{
			//ex: AND ecx, ecx (faster)
			//Do not call AND_Reg2ToReg1() because it is designed to return
			//when the operands are the same
			WC8( (0x22 | OperandSize));
			WC8( (0xC0 | (Reg1 << 3) | Reg2));
		}
	}
	else
	{
		WC8( (0x84 | OperandSize));
		WC8( (0xC0 | (Reg1 << 3) | Reg2));
	}
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void TEST_RegWithImm(u8 OperandSize, u8 iReg, u32 Data)
{
	if (iReg == Reg_EAX) {
		WC8(0xA8|OperandSize);
	} else {
		WC8( (0xf6 | OperandSize));
		WC8( (0xc0 | iReg));
	}
	WC32(Data);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void XCHG_Reg1WithReg2(u8 OperandSize, u8 Reg1, u8 Reg2)
{
	if(Reg1 == Reg2) return;	/* Note: if you are padding, do it manually with WC16() */
	WC8( (0x86 | OperandSize));
	WC8( (0xC0 | (Reg1 << 3) | Reg2));
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void XOR_ImmToEAX(u8 OperandSize, u32 Data)
{
	WC8( (0x34 | OperandSize));

	if(OperandSize == 0)
		WC8( Data);
	else
		WC32(Data);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void XOR_Reg2ToReg1(u32 OperandSize, u32 Reg1, u32 Reg2, u32 FlagsMatter)
{
    WC8( (0x32 | OperandSize));
    WC8( (0xC0 | (Reg1 << 3) | Reg2));
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void XOR_ImmToReg(u32 OperandSize, u32 Reg, u32 Data, u32 FlagsMatter)
{
	if((Data == 0)&&(!FlagsMatter)) return;

	if((Data < 128) || (Data >= (0xffffff80)))	/* [-128 to 127] */
	{
		XOR_ShortToReg(OperandSize, Reg, (unsigned char) Data);
		return;
	}

	if(Reg == Reg_EAX)
	{
		XOR_ImmToEAX(OperandSize, Data);
		return;
	}

	/* Normal execution */
	WC8( (0x80 | OperandSize));
	WC8( (0xF0 | Reg));
	if(OperandSize == 0)
	{
		WC8( Data);
	}
	else
	{
		WC32(Data);
	}
}

/*
 =======================================================================================================================
    When OperandSize is 0, this doesn't sign extend.
 =======================================================================================================================
 */
void OR_ShortToReg(u32 OperandSize, u32 Reg, u32 Data)
{
	WC8( (0x80 | (OperandSize * 3)));
	WC8( (0xC8 | Reg));
	WC8( Data);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void XOR_ShortToReg(u8 OperandSize, u8 Reg, u8 Data)
{
	WC8( (0x80 | (OperandSize * 3)));
	WC8( (0xF0 | Reg));
	WC8( Data);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void AND_Reg2ToReg1(u32 OperandSize, u32 Reg1, u32 Reg2, u32 FlagsMatter)
{
	if ((Reg2 == Reg1) && !FlagsMatter) return;	/* Note: for testing, use TEST. */
	WC8( (0x22 | OperandSize));
	WC8( (0xC0 | (Reg1 << 3) | Reg2));
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void OR_Reg2ToReg1(u32 OperandSize, u32 Reg1, u32 Reg2, u32 FlagsMatter)
{
	if((Reg2 == Reg1) && !FlagsMatter) return;
	WC8( (0x0A | OperandSize));
	WC8( (0xC0 | (Reg1 << 3) | Reg2));
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void ADD_Imm8sxToReg(u32 OperandSize, u32 Reg, u8 Data)
{
//    if (Data == 1) {INC_Reg(OperandSize, Reg); return;}
//    if (Data == 0xFF) {DEC_Reg(OperandSize, Reg); return;}
    
	WC8( (0x83));
	WC8( (0xC0 | Reg));
	WC8( Data);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void SUB_Imm8sxToReg(u32 OperandSize, u32 Reg, u8 Data, int FlagsMatter)
{
    if (!FlagsMatter)
    {
        if (Data == 0xFF) {INC_Reg(OperandSize, Reg); return;}
        if (Data == 1) {DEC_Reg(OperandSize, Reg); return;}
    }

	WC8( (0x83));
	WC8( (0xE8 | Reg));
	WC8( Data);
}


/*
 =======================================================================================================================
 =======================================================================================================================
 */
void AND_Imm8sxToReg(u32 OperandSize, u32 Reg, u32 Data)
{
	WC8( (0x80 | (OperandSize * 3)));
	WC8( (0xE0 | Reg));
	WC8( Data);
}


/*
 =======================================================================================================================
 =======================================================================================================================
 */
void CMP_sImm8WithReg(u32 OperandSize, u32 Reg, u32 Data)
{
	WC8( (0x83));
	WC8( (0xF8 | Reg));
	WC8( Data);
}

void INT3()
{
    WC8(0xCC);
}

#define LOGGING_DYNA(a)
#define ASSERT(x)

void MOVSS_XMMReg1ToXMMReg2(DWORD Reg1, DWORD Reg2)
{
	if (Reg1 == Reg2)
		return;

	WC8(0xF3);
	WC8(0x0F);
	WC8(0x11);
	WC8((unsigned char)(0xC0 | (Reg1 << 3) | Reg2));

	LOGGING_DYNA(sprintf(temp,"	movss %s, %s\n", RegXMMNames[Reg2], RegXMMNames[Reg1]));
}

void MOVSS_MemoryToXMMReg(DWORD Reg, u32 Address)
{
	LOGGING_DYNA(sprintf(temp,"	movss %s, [0x%08X]\n", RegXMMNames[Reg], Address));

	WC8(0xF3);
	WC8(0x0F);
	WC8(0x10);	

	Encode_Slash_R(Reg,ModRM_disp32,Address);	
}


void MOVSS_XMMRegToMemory(DWORD Reg, u32 Address)
{
	LOGGING_DYNA(sprintf(temp,"	movss [0x%08X],%s\n", Address,RegXMMNames[Reg]));

	WC8(0xF3);
	WC8(0x0F);
	WC8(0x11);	

	Encode_Slash_R(Reg,ModRM_disp32,Address);	
}


void MOVSS_ModRM_RegToXMMReg(DWORD RegXMM, DWORD RegX86)
{
	LOGGING_DYNA(sprintf(temp,"	movss %s, [%s]\n", RegXMMNames[RegXMM], RegNames[RegX86]));

	if (RegX86 == Reg_EBP)
		RegX86 = ModRM_disp8_EBP;
	
	WC8(0xF3);
	WC8(0x0F);
	WC8(0x10);	

	Encode_Slash_R(RegXMM,ModRM_EAX + RegX86,0);	
}


void MOVSS_XMMRegToModRM_Reg(DWORD RegXMM, DWORD RegX86)
{
	LOGGING_DYNA(sprintf(temp,"	movss [%s],%s\n", RegNames[RegX86],RegXMMNames[RegXMM]));

	WC8(0xF3);
	WC8(0x0F);
	WC8(0x11);	

	if (RegX86 == Reg_EBP)
		RegX86 = ModRM_disp8_EBP;

	Encode_Slash_R(RegXMM,ModRM_EAX + RegX86,0);	
}

void ADDSS_XMMReg2ToXMMReg1(DWORD Reg1, DWORD Reg2)
{
	LOGGING_DYNA(sprintf(temp,"	addss %s, %s\n", RegXMMNames[Reg1], RegXMMNames[Reg2]));

	WC8(0xF3);
	WC8(0x0F);
	WC8(0x58);
	WC8((unsigned char)(0xC0 | (Reg1 << 3) | Reg2));
}


void ADDSS_MemoryToXMMReg(DWORD Reg, u32 Address)
{
	LOGGING_DYNA(sprintf(temp,"	addss %s, [0x%08X]\n", RegXMMNames[Reg], Address));

	WC8(0xF3);
	WC8(0x0F);
	WC8(0x58);

	Encode_Slash_R(Reg,ModRM_disp32,Address);			
}


void SUBSS_XMMReg2ToXMMReg1(DWORD Reg1, DWORD Reg2)
{
	LOGGING_DYNA(sprintf(temp,"	subss %s, %s\n", RegXMMNames[Reg1], RegXMMNames[Reg2]));

	WC8(0xF3);
	WC8(0x0F);
	WC8(0x5C);
	WC8((unsigned char)(0xC0 | (Reg1 << 3) | Reg2));
}

void SUBSS_MemoryToXMMReg(DWORD Reg, u32 Address)
{
	LOGGING_DYNA(sprintf(temp,"	subss %s, [0x%08X]\n", RegXMMNames[Reg], Address));

	WC8(0xF3);
	WC8(0x0F);
	WC8(0x5C);

	Encode_Slash_R(Reg,ModRM_disp32,Address);			
}


void DIVSS_XMMReg2ToXMMReg1(DWORD Reg1, DWORD Reg2)
{
	LOGGING_DYNA(sprintf(temp,"	divss %s, %s\n", RegXMMNames[Reg1], RegXMMNames[Reg2]));

	WC8(0xF3);
	WC8(0x0F);
	WC8(0x5E);
	WC8((unsigned char)(0xC0 | (Reg1 << 3) | Reg2));
}



void DIVSS_MemoryToXMMReg(DWORD Reg, u32 Address)
{
	LOGGING_DYNA(sprintf(temp,"	divss %s, [0x%08X]\n", RegXMMNames[Reg], Address));

	WC8(0xF3);
	WC8(0x0F);
	WC8(0x5E);

	Encode_Slash_R(Reg,ModRM_disp32,Address);			
}



void MULSS_XMMReg2ToXMMReg1(DWORD Reg1, DWORD Reg2)
{
	LOGGING_DYNA(sprintf(temp,"	mulss %s, %s\n", RegXMMNames[Reg1], RegXMMNames[Reg2]));

	WC8(0xF3);
	WC8(0x0F);
	WC8(0x59);
	WC8((unsigned char)(0xC0 | (Reg1 << 3) | Reg2));
}

void MULSS_MemoryToXMMReg(DWORD Reg, u32 Address)
{
	LOGGING_DYNA(sprintf(temp,"	mulss %s, [0x%08X]\n", RegXMMNames[Reg], Address));

	WC8(0xF3);
	WC8(0x0F);
	WC8(0x59);

	Encode_Slash_R(Reg,ModRM_disp32,Address);			
}



void RSQRTSS_XMMReg2ToXMMReg1(DWORD Reg1, DWORD Reg2)
{
	LOGGING_DYNA(sprintf(temp,"	rsqrtss %s, %s\n", RegXMMNames[Reg1], RegXMMNames[Reg2]));

	WC8(0xF3);
	WC8(0x0F);
	WC8(0x52);
	WC8((unsigned char)(0xC0 | (Reg1 << 3) | Reg2));
}


void RSQRTSS_MemoryToXMMReg(DWORD Reg, u32 Address)
{
	LOGGING_DYNA(sprintf(temp,"	rsqrtss %s, [0x%08X]\n", RegXMMNames[Reg], Address));

	WC8(0xF3);
	WC8(0x0F);
	WC8(0x52);

	Encode_Slash_R(Reg,ModRM_disp32,Address);			
}


void SQRTSS_XMMReg2ToXMMReg1(DWORD Reg1, DWORD Reg2)
{
	LOGGING_DYNA(sprintf(temp,"	sqrtss %s, %s\n", RegXMMNames[Reg1], RegXMMNames[Reg2]));

	WC8(0xF3);
	WC8(0x0F);
	WC8(0x51);
	WC8((unsigned char)(0xC0 | (Reg1 << 3) | Reg2));
}

void SQRTSS_MemoryToXMMReg(DWORD Reg, u32 Address)
{
	LOGGING_DYNA(sprintf(temp,"	sqrtss %s, [0x%08X]\n", RegXMMNames[Reg], Address));

	WC8(0xF3);
	WC8(0x0F);
	WC8(0x51);

	Encode_Slash_R(Reg,ModRM_disp32,Address);			
}



void UCOMISS_XMMReg2WithXMMReg1(DWORD Reg1, DWORD Reg2)
{
	// compare and set eflags
	LOGGING_DYNA(sprintf(temp,"	ucomiss %s, %s\n", RegXMMNames[Reg1], RegXMMNames[Reg2]));

	WC8(0x0F);
	WC8(0x2E);	
	WC8((unsigned char)(0xC0 | (Reg1 << 3) | Reg2));
}


void UCOMISS_MemoryWithXMMReg(DWORD Reg, u32 Address)
{
	// compare and set eflags
	LOGGING_DYNA(sprintf(temp,"	ucomiss %s, [0x%08X]\n", RegXMMNames[Reg], Address));

	WC8(0x0F);
	WC8(0x2E);	

	Encode_Slash_R(Reg,ModRM_disp32,Address);			
}


void ANDPS_MemoryToXMMReg(DWORD Reg, u32 Address)
{
	ASSERT((Address&0xf) == 0);
	LOGGING_DYNA(sprintf(temp,"	andps %s, [0x%08X]\n", RegXMMNames[Reg], Address));

	WC8(0x0F);
	WC8(0x54);

	Encode_Slash_R(Reg,ModRM_disp32,Address);		
}

void XORPS_MemoryToXMMReg(DWORD Reg, u32 Address)
{
	ASSERT((Address&0xf) == 0);
	LOGGING_DYNA(sprintf(temp,"	xorps %s, [0x%08X]\n", RegXMMNames[Reg], Address));

	WC8(0x0F);
	WC8(0x57);

	Encode_Slash_R(Reg,ModRM_disp32,Address);		
}

void CVTSI2SS_MemoryToXMMReg(DWORD Reg, u32 Address)
{
	// convert integer to float
	LOGGING_DYNA(sprintf(temp,"	ctsi2ss %s, [0x%08X]\n", RegXMMNames[Reg], Address));

	WC8(0xF3);
	WC8(0x0F);
	WC8(0x2A);

	Encode_Slash_R(Reg,ModRM_disp32,Address);		
}


void RCPSS_XMMReg2ToXMMReg1(DWORD Reg1, DWORD Reg2)
{
	LOGGING_DYNA(sprintf(temp,"	rcpss %s, %s\n", RegXMMNames[Reg1], RegXMMNames[Reg2]));

	WC8(0xF3);
	WC8(0x0F);
	WC8(0x53);
	WC8((unsigned char)(0xC0 | (Reg1 << 3) | Reg2));
}


void CVTSS2SI_XMMRegToX86Reg(DWORD RegXMM, DWORD RegX86)
{
	// convert integer to float
	LOGGING_DYNA(sprintf(temp,"	cvtss2si %s, %s\n", RegNames[RegX86], RegXMMNames[RegXMM]));

	WC8(0xF3);
	WC8(0x0F);
	WC8(0x2D);

	WC8((unsigned char)(0xC0 | (RegX86 << 3) | RegXMM));
}

void CVTTSS2SI_XMMRegToX86Reg(DWORD RegXMM, DWORD RegX86)
{
	// convert integer to float, powerful :D
	LOGGING_DYNA(sprintf(temp,"	cvttss2si %s, %s\n", RegNames[RegX86], RegXMMNames[RegXMM]));

	WC8(0xF3);
	WC8(0x0F);
	WC8(0x2C);

	WC8((unsigned char)(0xC0 | (RegX86 << 3) | RegXMM));
}


void CVTTSS2SI_MemoryToX86Reg(u32 Address, DWORD RegX86)
{
	// convert integer to float, powerful :D
	
	WC8(0xF3);
	WC8(0x0F);
	WC8(0x2C);

	Encode_Slash_R(RegX86,ModRM_disp32,Address);	
}


void MOVD_XMMToReg(DWORD xmm, DWORD Reg)
{	
	WC8((unsigned char) (0x66));
	WC8((unsigned char) (0x0f));
	WC8((unsigned char) (0x7e));

	WC8((unsigned char) (0xC0 | (xmm << 3) | Reg));

	LOGGING_DYNA(sprintf(temp,"	movd %s, %s\n", RegNames[Reg], RegXMMNames[Reg]));
}


void MOVD_RegToXMM(DWORD Reg, DWORD xmm)
{	
	WC8((unsigned char) (0x66));
	WC8((unsigned char) (0x0f));
	WC8((unsigned char) (0x6e));

	WC8((unsigned char) (0xC0 | (Reg << 3) | xmm));

	LOGGING_DYNA(sprintf(temp,"	movd %s, %s\n", RegXMMNames[Reg], RegNames[Reg]));
}



void MOVD_XMMToMemory(DWORD Reg, DWORD ModRM, u32 Address)
{
	WC8((unsigned char) (0x66));
	WC8((unsigned char) (0x0f));
	WC8((unsigned char) (0x7e));

	Encode_Slash_R(Reg, ModRM, Address);
}

void MOVD_MemoryToXMM(DWORD Reg, DWORD ModRM, u32 Address)
{
	WC8((unsigned char) (0x66));
	WC8((unsigned char) (0x0f));
	WC8((unsigned char) (0x6e));

	Encode_Slash_R(Reg, ModRM, Address);
}

void MOVSS_XMMToMemory(DWORD Reg, DWORD ModRM, u32 Address)
{
	WC8(0xF3);
	WC8(0x0F);
	WC8(0x11);

	Encode_Slash_R(Reg, ModRM, Address);
}

void MOVSS_MemoryToXMM(DWORD Reg, DWORD ModRM, u32 Address)
{
	WC8(0xF3);
	WC8(0x0F);
	WC8(0x10);

	Encode_Slash_R(Reg, ModRM, Address);

}

void MOVLPS_XMMToMemory(DWORD Reg, DWORD ModRM, u32 Address)
{
  WC8(0x0F);
  WC8(0x13);  

  Encode_Slash_R(Reg, ModRM, Address);
}

void MOVLPS_MemoryToXMM(DWORD Reg, DWORD ModRM, u32 Address)
{
  WC8(0x0F);
  WC8(0x12);  

  Encode_Slash_R(Reg, ModRM, Address);

}


void MOVAPS_MemoryToXMM(DWORD Reg, DWORD ModRM, u32 Address)
{
	WC8(0x0F);
	WC8(0x28);
	
	Encode_Slash_R(Reg,ModRM_disp32,Address);	
}

void MOVAPS_XMMToMemory(DWORD Reg, DWORD ModRM, u32 Address)
{
	WC8(0x0F);
	WC8(0x29);
	
	Encode_Slash_R(Reg,ModRM_disp32,Address);	
}

void MOVAPS_XMMReg1ToXMMReg2(DWORD Reg1, DWORD Reg2)
{
	if (Reg1 == Reg2)
		return;

	WC8(0x0F);
	WC8(0x29);	
	WC8((unsigned char)(0xC0 | (Reg1 << 3) | Reg2));
}

void MULPS_XMMReg2ToXMMReg1(DWORD Reg1, DWORD Reg2)
{
	WC8(0x0F);
	WC8(0x59);	
	WC8((unsigned char)(0xC0 | (Reg1 << 3) | Reg2));
}

void MULPS_MemoryToXMMReg(DWORD Reg1, u32 Address)
{
	WC8(0x0F);
	WC8(0x59);	
	Encode_Slash_R(Reg1,ModRM_disp32,Address);	
}

void SHUFPS_XMMReg2ToXMMReg1(DWORD Reg1, DWORD Reg2, DWORD uMask)
{
	WC8(0x0F);
	WC8(0xC6);
	WC8((unsigned char)(0xC0 | (Reg1 << 3) | Reg2));
	WC8(BYTE(uMask));

}

void ADDPS_XMMReg2ToXMMReg1(DWORD Reg1, DWORD Reg2)
{
	WC8(0x0F);
	WC8(0x58);	
	WC8((unsigned char)(0xC0 | (Reg1 << 3) | Reg2));
}

void MOVHLPS_XMMReg2ToXMMReg1(DWORD Reg1, DWORD Reg2)
{
	WC8(0x0F);
	WC8(0x12);	
	WC8((unsigned char)(0xC0 | (Reg1 << 3) | Reg2));
}

void MOVLHPS_XMMReg2ToXMMReg1(DWORD Reg1, DWORD Reg2)
{
	WC8(0x0F);
	WC8(0x16);	
	WC8((unsigned char)(0xC0 | (Reg1 << 3) | Reg2));
}

void PREFETCHT0_Memory(u32 Address)
{
	WC8(0x0F);
	WC8(0x18);
	WC8(0x0D);
	WC32(Address);
}
void PREFETCHT0_IReg(DWORD uReg)
{
	WC8(0x0F);
	WC8(0x18);
	WC8(0x8|BYTE(uReg));
}
