/////////////////////////////////////////////////////////////////////////////////////////////////////
// M O D U L E  B E G I N ///////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef _DISASM_H
#define _DISASM_H

#include "../W32Util/DialogManager.h"
#include "CtrlDisasmView.h"
#include "ARMDebugInterface.h"
#include "CPURegsInterface.h"
#include "../../Globals.h"
#include "../../Core/CPU.h"

/////////////////////////////////////////////////////////////////////////////////////////////////////
// C L A S S ////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////

class CDisasm : public Dialog
{
private:
	RECT minRect;
	RECT regRect;
	RECT disRect;
	
	CPU *cpu;
	ARMDebugInterface *cpudeb;
	
	BOOL DlgProc(UINT message, WPARAM wParam, LPARAM lParam);

public:
	int index; //helper 

	CDisasm(HINSTANCE _hInstance, HWND _hParent, CPU *_arm);
	~CDisasm();
	//
	// --- tools ---
	//
	// Update Dialog
	void UpdateDialog(bool _bComplete = false);
	// SetDebugMode 
	void SetDebugMode(bool _bDebug);
	// show dialog
	void Goto(u32 addr);
	void NotifyMapLoaded();
};

#endif