#include "../Core/Host.h"

class WindowsHost : public Host
{
	HWND displayWindow;
public:
	WindowsHost(HWND _displayWindow)
	{
		displayWindow=_displayWindow;
	}
	void UpdateMemView();
	void UpdateDisassembly();
	void UpdateUI();
	void SetDebugMode(bool mode);

	void AddSymbol(std::string name, u32 addr, u32 size, int type);

	void InitGL();
	void BeginFrame();
	void EndFrame();
	void ShutdownGL();

	void InitSound(Mixer *mixer);
	void UpdateSound();
	void ShutdownSound();

	u8 *AllocExecMemory(size_t size);
	void FreeExecMemory(u8 *ptr);

	bool IsDebuggingEnabled();
	void BootDone();
	void PrepareShutdown();
	bool AttemptLoadSymbolMap();

};